#!/bin/bash

linklib() {
i=$1
bits=$2
where=$3
j=`echo $i |sed -e 's/\.so\..*/.so.1.0./'`
case "$j" in
 libcrypto.so.1.0. | libcurl.so. | libssl.so.1.0. )
declare -a tablibs
declare -a tabdir
tablibs=( `file -L $(find /lib* /usr/lib* /usr/local/lib* -name "$j*" 2>/dev/null)| grep "ELF $2-bit LSB " | sed -e 's/:  *ELF .*$//'`)

best=0
len=256
for lib in $(seq 0 $((${#tablibs[@]} - 1)))
do
  slashs=$(echo "${tablibs[$lib]}" | sed -e 's/[^/]//g')
  if [ ${#slashs} -lt $len ]
    then
      best=$lib
      len=${#slashs}
  fi
done
ln -s "${tablibs[$best]}" "$where/$i"  ;;
  * )
  echo "can't make link for $i" ;;

  esac

}

# $1: TESTRTDIR
if [ "A$1" != "A" ]
then
  TESTRTDIR="$1"
fi
if [ -d "$TESTRTDIR" ]
then

declare -a missignlist64
LD_LIBRARY_PATH=$TESTRTDIR/lib/intel/linux:$TESTRTDIR/lib/intel/linux_64:$LD_LIBRARY_PATH
export LD_LIBRARY_PATH

missignlist64=( $( ldd $TESTRTDIR/bin/intel/linux_64/attolcc4 | grep 'not found' | sed -e 's/=>.*//' ))
for element in $(seq 0 $((${#missignlist64[@]} - 1)))
  do
   linklib "${missignlist64[$element]}" 64 "$TESTRTDIR/lib/intel/linux_64"
done

else
  echo "error missign or bad parameter"
  echo "usage : $0 <testrtdir>"
fi
